//
// I2C List 
// with devices database
// 
// Jan 02, 2011 release 1 - LinkM library
// May 18, 2011 release 2 - Nick Gammon 20th April 2011
// Dec 11, 2011 release 3 - updated database
// 
// Connections to Arduino
// PWR - -- gnd -- black -- Gnd
// PWR + -- +5V -- red   -- 5V
// I2C d -- SDA -- green -- Analog In 4
// I2C c -- SCK -- blue  -- Analog In 5
// 
// Beware! For 3.3V I2C devices, use appropriate level converter
// 
// Based on 
// 2007-8, Tod E. Kurt, ThingM, http://thingm.com/
// 
// 


#include "Wire.h"
// #include"BlinkM_funcs.h"

//#include <avr/pgmspace.h>  // for progmem stuff
//
//#define BLINKM_ARDUINO_POWERED 1
//
//byte blinkm_addr = 0x09; // the default address of all BlinkMs

// There are cases where we can't use the obvious Serial.println(str) because
// the string is and Serial doesn't know how to deal with that
// (we store strings in PROGMEM instead of normal RAM to save RAM space)
//void printProgStr(const prog_char str[])
//{
//  char c;
//  if(!str) return;
//  while((c = pgm_receive_byte(str++)))
//    Serial.print(c,BYTE);
//}

// Write or read according to framework
static void _send(uint8_t ui) {
#if defined(WIRING) // Wiring specific
  Wire.write(ui);
#elif defined(ARDUINO) && (ARDUINO >= 100)
  Wire.write(ui);
#elif defined(ENERGIA)
  Wire.write(ui);
#else
  Wire.send(ui);
#endif
}

static uint8_t _receive() {
#if defined(WIRING) // Wiring specific
  return Wire.read();
#elif defined(ARDUINO) && (ARDUINO >= 100)
  return Wire.read();
#elif defined(ENERGIA)
  return Wire.read();
#else
  return Wire.receive();
#endif
}


// arduino setup function
void setup()
{
  Wire.begin();
  delay(1000); // wait a bit *longer for things to stabilize

  Serial.begin(19200);
  Serial.print("\n\n\n***\n");
}


void I2C_Scan(byte vFrom, byte vTo) {
  for (byte addr=vFrom; addr<vTo; addr++)
  {
    Wire.beginTransmission (addr);
    Serial.println(addr);  //display current address under test
    delay(500);  //delay here to let the bus set up
    if (Wire.endTransmission () == 0)      {
      Serial.print(addr, DEC);
      Serial.print("d\t");
      Serial.print(addr, HEX);
      Serial.print("h7\t");
      Serial.print(addr <<1, HEX);
      Serial.print("h8\t");
      Serial.println();
      
      //send some data to display
      Wire.beginTransmission(addr);
      Wire.write(7);
      Wire.write(254);
      Wire.write(88);
      Wire.write("Hello World!!!");
      Wire.endTransmission();
      
    } // end of good response
    delay (500);  // give devices time to recover
  } // end of for loop
}


// arduino loop function
void loop()
{
  byte command;
  byte result;

  Serial.println("Scanning I2C bus:");
  I2C_Scan(0x28, 0x7C);  //scan only in range of known good address 0x28
  Serial.println();
  
  //print message when scan is complete
  Serial.println("Scan Complete");
  delay(200);

  while (Serial.available()==0);  // Look for char in serial que and process if found
  command = Serial.read();
}






